program solitair;
{ UJA 1.00, im Hau-Ruck-Verfahren von hinten bis vorne am 19.07.1994 }

uses crt,dos,graph,BGIdriv,BGIFont,drivers;

const xmax=12; ymax=12; dx=32; dy=32; ox=0; oy=8; lsize=1024;
      levelfile='solitair.lev';
      imafile  ='soli.ima';

type feld  = array[0..xmax,0..ymax] of integer;
     liste = array[0..lsize] of record xvon,yvon,xnach,ynach:integer end;
     fliste= array[1..8] of record lname,filnam:string; end;

{$i f:\inc\initscr.inc }
{$i f:\inc\mouse.inc   }
{$i f:\inc\intu1.inc   }

var i,j,k,mx,my,m,g,xx,yy,x1,y1,x2,y2,nl:integer;
    f,fo                 :feld;
    l                    :liste;
    ima                  :array[1..3] of image;
    igad                 :array[1..8] of boolgadget;
    itext1,itext2,itext3 :array[1..16] of IntuiText;
    ibord1,ibord2,ibord3 :array[1..8] of Border;
    iborda,ibordb        :Border;
    xy1,xy2,xy3,xy4      :koords;
    ok,fertig,select,ende:boolean;
    ch                   :char;
    temp                 :string;
    flst                 :fliste;


{ --- }

procedure setzefarben;
const cmap:array [0..15,0..2] of integer =
           (( 0,16,23),( 0, 0, 0),( 5,22,33),(14,29,43),
            (27,39,53),(44,51,63),(42, 0,20),(47, 6,21),
            (52,15,24),(57,25,29),(63,38,38),(52,29,20),
            (54,40,27),(57,50,34),(60,58,41),(62,63,50));
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,cmap[i,0],cmap[i,1],cmap[i,2]);
   setpalette(i,i);
end;
setbkcolor(0);
end;

{ --- }

procedure initstructures;
var i,size,gelesen:integer;
    f             :file;
begin
   assign(f,imafile);
   reset(f,1);
   for i:=1 to 3 do begin
   blockread(f,ima[i],sizeof(image));
   with ima[i] do begin
      size:=imagesize(1,1,width,height);
      getmem(p_data,size);
      blockread(f,p_data^,size,gelesen);
   end;
   end;
   close(f);

   itext1[1].itext:='  z u r  c k  ';
   itext1[2].itext:='    N e u      ';
   itext1[3].itext:='   Q u i t     ';
   itext1[4].itext:='D i a g o n a l';
   itext1[5].itext:='S t a n d a r d';

   for i:=1 to 5 do with itext1[i] do begin
      x:=11;
      y:=4;
      fpen:=0;
      bpen:=12;
      drmode:=jam1;
      p_nexttext:=addr(itext2[i]);
   end;
   for i:=1 to 5 do with itext2[i] do begin
      x:=13;
      y:=4;
      fpen:=15;
      bpen:=12;
      drmode:=jam1;
      itext:=itext1[i].itext;
      p_nexttext:=addr(itext3[i]);
   end;
    for i:=1 to 5 do with itext3[i] do begin
      x:=12;
      y:=itext1[i].y;
      fpen:=6;
      bpen:=itext1[i].bpen;
      drmode:=jam1;
      itext:=itext1[i].itext;
      p_nexttext:=nil;
   end;

   xy1[0]:=0;  xy1[1]:=0;      xy1[2]:=143;     xy1[3]:=xy1[1]; xy1[4]:=xy1[2];
   xy1[5]:=15; xy1[6]:=xy1[0]; xy1[7]:=xy1[5]; xy1[8]:=xy1[0]; xy1[9]:=xy1[1];
   xy2[0]:=1; xy2[1]:=14; xy2[2]:=xy2[0];
   xy2[3]:=1; xy2[4]:=142; xy2[5]:=xy2[3];
   xy3[0]:=1;      xy3[1]:=14;     xy3[2]:=142;
   xy3[3]:=xy3[1]; xy3[4]:=xy3[2]; xy3[5]:=xy3[0];
   xy4[0]:=0;  xy4[1]:=0;      xy4[2]:=30;     xy4[3]:=xy4[1]; xy4[4]:=xy4[2];
   xy4[5]:=30; xy4[6]:=xy4[0]; xy4[7]:=xy4[5]; xy4[8]:=xy4[0]; xy4[9]:=xy4[1];

   for i:=1 to 5 do begin
   with ibord1[i] do begin
      x:=0; y:=0; fpen:=1; bpen:=12; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy1);
      p_nextborder:=addr(ibord2[i]);
   end;
   with ibord2[i] do begin
      x:=0; y:=0; fpen:=15; bpen:=12; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy2);
      p_nextborder:=addr(ibord3[i]);
   end;
   with ibord3[i] do begin
      x:=0; y:=0; fpen:=11; bpen:=12; drmode:=jam1; ecken:=3;
      p_ecken:=addr(xy3);
      p_nextborder:=nil;
   end;
   end;
   with iborda do begin
      x:=1; y:=1; fpen:=3; bpen:=1; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy4);
      p_nextborder:=addr(ibordb);
   end;
   with ibordb do begin
      x:=0; y:=0; fpen:=1; bpen:=1; drmode:=jam1; ecken:=5;
      p_ecken:=addr(xy4);
      p_nextborder:=nil;
   end;

   for i:=1 to 5 do with igad[i] do begin
      id:=i; x